package com.syjy.calculate.function;

import com.googlecode.aviator.AviatorEvaluator;
import com.googlecode.aviator.Expression;
import com.googlecode.aviator.Options;
import com.googlecode.aviator.runtime.RuntimeUtils;
import com.googlecode.aviator.runtime.function.AbstractFunction;
import com.googlecode.aviator.runtime.type.AviatorDecimal;
import com.googlecode.aviator.runtime.type.AviatorObject;
import com.googlecode.aviator.runtime.type.Sequence;
import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;

/**
 * 计算准确率 :均方根准确率绝对值
 *
 * @author zcl
 * @version 1.0
 * @since 2022/9/8 9:30
 */
public class RootMeanSquaredErrorA extends AbstractFunction {
    @Override
    public AviatorObject call(Map<String, Object> env, AviatorObject arg1) {
        // 获取参数
        Object first = arg1.getValue(env);
        // 获取Σ|sj-yc|
        env.put("list",first);
        BigDecimal sumDifferenceAbsolute = new BigDecimal(String.valueOf(AviatorEvaluator.execute("sumDifferenceAbsolute(list)",env)));
        BigDecimal sum = BigDecimal.ZERO;
        Sequence seq = RuntimeUtils.seq(first, env);
        // 循环集合获取实际功率、预测功率信息并计算
        for (Object obj : seq) {
            Map<String, Object> map = (Map<String, Object>) obj;
            map.put("sumDifferenceAbsolute",sumDifferenceAbsolute);
            BigDecimal forResult = (BigDecimal) AviatorEvaluator.execute("differenceSquare(sj,yc) * (differenceAbsolute(sj,yc)/sumDifferenceAbsolute)",map);
            sum = sum.add(forResult);
        }
        Map<String, Object> map = new HashMap<>();
        map.put("sum",sum);
        // 获取开根号结果并转为BigDecimal类型(因为Aviator中，只要有double类型的数据进行计算，结果就会是double类型，开根号的计算结果必为double，所以这里先将开根号计算的结果转为BigDecimal)
        BigDecimal sqrtValue = new BigDecimal(String.valueOf(AviatorEvaluator.execute("math.sqrt(sum)",map)));
        // 获取容量
        BigDecimal rl = (BigDecimal)env.get("rl");
        map.put("sqrtValue",sqrtValue);
        map.put("rl",rl);
        BigDecimal result = (BigDecimal)AviatorEvaluator.execute("1-(sqrtValue/rl)",map);
        return new AviatorDecimal(result);
    }
    @Override
    public String getName() {
        return "rootMeanSquaredErrorA";
    }
}
